<template>
  <div>
    <div class="field">
      <label for="email">Email:</label>
      <input v-model="email" class="textarea" required />
    </div>
    <div v-if="msg.email" class="error">
      <strong>{{ msg.email }}</strong>
    </div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      msg: [],
    }
  },
  computed: {
    email: {
      get() {
        return this.$store.state.email
      },
      set(value) {
        this.validateEmail(value)
        this.$store.commit('updateEmail', value)
      },
    },
  },
  methods: {
    validateEmail(val) {
      // eslint-disable-next-line no-useless-escape
      if (/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(val)) {
        this.msg.email = ''
      } else {
        this.msg.email = 'Endereço de email inválido'
      }
    },
  },
}
</script>

<style>
.field {
  height: 60px;
  display: flex;
  justify-content: space-between;
}

.textarea {
  border: 1px solid black;
  height: 30px;
  width: 70%;
}
.error {
  width: 250px;
}
</style>
